; 0 - opti895, 1 - umc498, 2 - sis471, 3 - vlsi330
                .186

IODELAY         MACRO
                JMP     SHORT $+2               ; delay for I/O
		JMP	SHORT $+2		; delay for I/O
                ENDM

CODE            SEGMENT BYTE PUBLIC
                ASSUME  CS:CODE,DS:CODE

                ORG     0

DEVICE_DATA     PROC    FAR
NEXT_DEV        DD      -1
ATTRIBUTES      DW      8000H
P_STRATEGY      DW      OFFSET STRATEGY
P_INTERRUPT     DW      OFFSET INTERRUPT
DEV_NAME        DB      'SRAMU   '
RH_OFF          DW      ?
RH_SEG          DW      ?
F8X8            LABEL   BYTE
                INCLUDE 8X8.INC
F8X14           LABEL   BYTE
                INCLUDE 8X14.INC
F8X16           LABEL   BYTE
                INCLUDE 8X16.INC
F9X14           LABEL   BYTE
                INCLUDE 9X14.INC
                DB      0
F9X16           LABEL   BYTE
                INCLUDE 9X16.INC
                DB      0
BUFFERX         DB      'FONTS DECIMAL ADDRESSES: '
BUFFERF         DB      '8X8=23, 8X14=2071, 8X16=5655, 9X14=9751, 9X16=10052'
ERRMSG          DB      'ERROR: INCORRECT PARAMETERS',13,10,'$'
MSG             DB      'Shadow RAM Utilizier v1.04 by V.Lidovski IV-2016'
                DB      13,10,'$'
DEVICE_DATA     ENDP

STRATEGY        PROC    FAR
                MOV     CS:RH_OFF,BX
                MOV     CS:RH_SEG,ES
                RETF
STRATEGY        ENDP

INTERRUPT       PROC    FAR
                PUSH    BP
                PUSH    AX
                PUSH    BX
                PUSH    CX
                PUSH    DX
                PUSH    DI
                PUSH    SI
                PUSH    DS
                PUSH    ES
                PUSH    CS
                POP     DS
                LES     DI,DWORD PTR RH_OFF
                MOV     BL,ES:[DI+2]
                MOV     AX,8003H
                OR      BL,BL
                jz  xl1
                Jmp     L2

xl1:            PUSH    ES
                PUSH    DI
                CLD
                LES     DI,ES:[DI+12H]
                MOV     AL,'/'
                CALL    FINDAL
                jz xl2
                Jmp     ERR1

xl2:            MOV     AL,'F'
                CALL    FINDALS
                JNZ     LCONT1

                MOV     BUFFERF,CH
LCONT1:         MOV     AL,'C'
                CALL    FINDALS
                JNZ     LCONT11

                MOV     BUFFERF+3,CH
LCONT11:        MOV     AL,'O'
                CALL    FINDALS
                JNZ     LCONT12

                CALL    FINDAL
                MOV     CL,12
                JZ      LCONT14

LCONT12:        MOV     AL,'U'
                CALL    FINDALS
                JNZ     LCONT12Z

                CALL    FINDAL
                MOV     CX,10AH
                JZ      LCONT14

LCONT12Z:       MOV     AL,'V'
                CALL    FINDALS
                JNZ     LCONT12X

                CALL    FINDAL
                MOV     CX,318H    ;3 - chipset #, 18h=24 blocks of RAM
                JZ      LCONT14

LCONT12X:       MOV     AL,'S'
                CALL    FINDALS
                JNZ     ERR1

                CALL    FINDAL
                MOV     CX,206H
LCONT14:        XOR     SI,SI
                MOV     BUFFERX,CH
LCONT3:         INC     SI
                MOV     AL,ES:[DI]
                INC     DI
                CMP     AL,'+'
                JZ      LCONT7

                CMP     AL,'-'
                JNZ     ERR1

LCONT7:         MOV     BUFFERX[SI],AL
                DEC     CL
                JNZ     LCONT3

                CALL    MYMAIN
                CALL    WAMSG
LLLX:           POP     DI
                POP     ES
                MOV     WORD PTR ES:[DI+0EH],0
                MOV     ES:[DI+10H],CS
                MOV     AX,100H
L2:             MOV     ES:[DI+3],AX
                POP     ES
                POP     DS
                POP     SI
                POP     DI
                POP     DX
                POP     CX
                POP     BX
                POP     AX
                POP     BP
                RETF

ERR1:           CALL    WAMSG
                LEA     DX,ERRMSG
                MOV     AH,9
                INT     21H
                JMP     LLLX
INTERRUPT       ENDP

MYMAIN          PROC    NEAR
                XOR     SI,SI
                XOR     DH,DH
                XOR     BX,BX
                CMP     BUFFERX,3
                JZ      VLSI330

                CMP     BUFFERX,1
                JZ      UMC498
                JNC xl3
                jmp     OPTI895
xl3:            JMP     SIS471

;VLSI330 should be after MYMAIN for compatibility with 80286
VLSI330:        out 0fbh,al       ;WRITE ENABLE to chipset index registers
                cmp bufferf,0     ;install fonts
                jnz SHV0A

                mov al,0fh        ;open video ROM
                out 0ech,al
                in al,0edh
                push ax
                or al,0fh
                out 0edh,al
                call GENP
                ;mov al,0fh        ;close video ROM
                ;out 0ech,al
                pop ax
                out 0edh,al
SHV0A:          mov dl,0dh
                XOR SI,SI
SHV0:           MOV     CX,4
                xor dh,dh
SHV2:           INC     SI
                shr dh,2
                CMP     BUFFERX[SI],'+'
                JNZ     SHV1

                OR      DH,0c0h
SHV1:           loop     SHV2

                mov al,dl
                out 0ech,al
                in al,0edh
                or al,dh
                inc dl
                out 0edh,al
                CMP     si,24
                JNZ     SHV0

                out 0f9h,al        ;WRITE disABLE to chipset index registers
                RETN

UMC498:         MOV     CX,0C002H
                MOV     DL,80H
                CMP     BUFFERF+3,0
                JZ      SHU0

                MOV     CH,40H
SHU0:           PUSH    CX
                PUSH    CX
SHU2:           INC     SI
                CMP     BUFFERX[SI],'+'
                JNZ     SHU1
                OR      DH,CH
                OR      BL,DL
SHU1:           SHR     DL,1
                SHR     CH,CL
                JNZ     SHU2

                MOV     CL,31H
                CALL    IN498
                OR      AH,DH
                CALL    OUT498

                XOR     DH,DH
                POP     CX
SHU4:           INC     SI
                CMP     BUFFERX[SI],'+'
                JNZ     SHU5
                OR      DH,CH
                OR      BL,DL
SHU5:           SHR     DL,1
                SHR     CH,CL
                JNZ     SHU4

                MOV     CL,32H
                CALL    IN498
                OR      AH,DH
                CALL    OUT498

                XOR     DH,DH
                POP     CX
                INC     SI
                CMP     BUFFERX[SI],'+'
                JNZ     SHU9
                OR      DH,CH
                MOV     BH,8
SHU9:           SHR     CH,CL

                INC     SI
                CMP     BUFFERX[SI],'+'
                JNZ     SHU6
                OR      BH,4
                OR      DH,CH

SHU6:           MOV     CL,35H
                CALL    IN498
                OR      AH,DH
                NOT     BH
                AND     AH,BH
                CALL    OUT498

                PUSH    BX

                CMP     BUFFERF,0
                JZ      SHU11

SHU3:           POP     BX
                MOV     CL,33H
                MOV     AH,BL
                NOT     AH
                JMP    OUT498

SHU11:          MOV     CL,33H          ; disable write protection of video ROM
                CALL    IN498
                AND     AH,3FH
                CALL    OUT498
                CALL    GENP
                JMP     SHU3

OPTI895:        MOV     AX,1001H
SHO2:           INC     SI
                CMP     BUFFERX[SI],'+'
                JNZ     SHO1
                OR      DH,AL
SHO1:           SHL     AX,1
                JNC     SHO2

                OR      DH,DH
                MOV     BUFFERF+1,DH
                JNZ     SHO12

                CMP     BUFFERF,0
                JNZ     SHO11

SHO12:          MOV     CL,26H          ; WRITE ENABLE, RANGE C000-CFFF
                CALL    IN895
                MOV     BUFFERF+2,AH
                AND     AH,0DFH
                CALL    OUT895

                OR      DH,DH
                JZ      SHO11

                MOV     BX,0310H
SHO21:          MOV     CL,26H          ; ENABLE SHADOW, RANGE C000-CFFF
                CALL    IN895
                OR      AH,DH
                CALL    OUT895

                XOR     DH,DH
SHO11:          MOV     AL,1
SHO6:           INC     SI
                CMP     BUFFERX[SI],'+'
                JNZ     SHO5
                OR      DH,AL
SHO5:           SHL     AL,1
                JNZ     SHO6

                XOR     DL,DL
                TEST    DH,0FH
                JZ      SHO14
                OR      DL,10H
                OR      BX,0C20H
SHO14:          TEST    DH,0F0H
                JZ      SHO15
                OR      DL,8
;                OR      BX,0F040H
SHO15:          OR      DH,DH
                JZ      SHO16

                MOV     CL,22H
                CALL    IN895
                NOT     DL
                AND     AH,DL
                CALL    OUT895

                INC     CL
                MOV     AH,DH
                CALL    OUT895

SHO16:          OR      BX,BX
                JZ      SHO18

                MOV     CL,2FH
                CALL    IN895
                OR      AH,BH
                CALL    OUT895

                DEC     CL
                CALL    IN895
                OR      AH,BL
                CALL    OUT895

SHO18:          CMP     BUFFERF,0
                JNZ     SHO17

                CALL    GENP

                CMP     BUFFERF+1,0
                JNZ     SHO17

                MOV     AH,BUFFERF+2
                MOV     CL,26H
                CALL    OUT895
SHO17:          RETN

SIS471:         MOV     AX,401H
SHS2:           INC     SI
                CMP     BUFFERX[SI],'+'
                JNZ     SHS1
                OR      DH,AL
SHS1:           SHL     AX,1
                JNC     SHS2

                OR      DH,DH
                MOV     BUFFERF+1,DH
                JNZ     SHS12

                CMP     BUFFERF,0
                JNZ     SHS11

SHS12:          MOV     CL,52H          ; WRITE ENABLE,
                CALL    IN471           ; RANGE C000-EFFF (ALL SHADOW RAM)
                AND     AH,0BFH
                CALL    OUT471

                OR      DH,DH
                JZ      SHS11

SHS21:          MOV     CL,52H          ; ENABLE SHADOW, RANGE C000-EFFF
                CALL    IN471
                OR      AH,DH
                CALL    OUT471

SHS11:          CMP     BUFFERF,0
                JNZ     SHS17

                CALL    GENP

                CMP     BUFFERF+1,0
                JNZ     SHS17

                MOV     CL,52H
                CALL    IN471
                OR      AH,40H
                CALL    OUT471
SHS17:          RETN

MYMAIN          ENDP

FINDAL          PROC    NEAR    ;return ZF=1 if successful, cx = len-pos
                PUSH    DI
                MOV     AH,AL
                MOV     AL,10
                MOV     CX,128
                REPNZ
                SCASB
                SUB     CL,128
                NEG     CL
                MOV     AL,AH
                POP     DI
                REPNZ
                SCASB
                RETN
FINDAL          ENDP

FINDALS         PROC    NEAR    ;find AL in any case
                PUSH    DI
                CALL    FINDAL
                POP     DI
                JZ      EP1

                OR      AL,20H    ;lowercase
                PUSH    DI
                CALL    FINDAL
                POP     DI
EP1:            RETN
FINDALS         ENDP

GENP            PROC    NEAR
                CALL    LDFNTS
                CALL    SETCRC
                JMP     FLUSHC
GENP            ENDP

LDFNTS          PROC    NEAR
                MOV     AX,1130H
                MOV     BH,2
                INT     10H
                MOV     DI,BP
                LEA     SI,F8X14
                MOV     CX,3584
                REP
                MOVSB
                MOV     AX,1130H
                MOV     BH,3
                INT     10H
                MOV     DI,BP
                LEA     SI,F8X8
                MOV     CX,2048
                REP
                MOVSB

                MOV     AX,1130H
                MOV     BH,6
                INT     10H
                MOV     DI,BP
                LEA     SI,F8X16
                MOV     CX,4096
                REP
                MOVSB

                MOV     AX,1130H
                MOV     BH,5
                INT     10H
                MOV     DI,BP
                LEA     SI,F9X14
                XOR     AL,AL
L6:             MOV     CX,15
                CMP     BYTE PTR ES:[DI],AL
                JZ      L5
                CMP     BYTE PTR DS:[SI],AL
                JNZ     L9
                REP
                STOSB
                JMP     L6
L9:             REP
                MOVSB
                JMP     L6

L5:             MOV     AX,1130H
                MOV     BH,7
                INT     10H
                MOV     DI,BP
                LEA     SI,F9X16
                XOR     AL,AL
L3:             MOV     CX,17
                CMP     BYTE PTR ES:[DI],AL
                JZ      L4
                CMP     BYTE PTR DS:[SI],AL
                JNZ     L8
                REP
                STOSB
                JMP     L3
L8:             REP
                MOVSB
                JMP     L3

L4:             INC     DI
                MOV     AX,3            ; INIT VIDEO MODE
                INT     10H
                RETN
LDFNTS          ENDP

WAMSG           PROC    NEAR
                LEA     DX,MSG
                MOV     AH,9
                INT     21H
                RETN
WAMSG           ENDP

FLUSHC          PROC    NEAR
                PUSH    DS
                MOV     DL,8            ; CLEAR UP TO 512KB CACHE RAM
                SUB     BX,BX
L1:             MOV     DS,BX
                SUB     SI,SI
                MOV     CX,0FFFFH
                REP
                LODSB
                ADD     BH,10H
                DEC     DL
                JNZ     L1

                POP     DS
                RETN
FLUSHC          ENDP
                
SETCRC          PROC    NEAR
                PUSH    ES
                MOV     AX,0C000H       ; SET CORRECT 32KB VIDEO ROM CHECKSUM
                MOV     ES,AX
                XOR     AX,AX
                MOV     BX,AX
L7:             ADD     AL,BYTE PTR ES:[BX]
                INC     BX
                JNS     L7
                NEG     AL
                POP     ES
                STOSB
                RETN
SETCRC          ENDP
                
                INCLUDE 498IO.INC
                INCLUDE 895IO.INC
                INCLUDE 471IO.INC

CODE            ENDS

                END
